
/*
 * $Id: LogComment.cc,v 1.1.1.1 1999/01/27 08:40:44 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include "Clock.h"
#include "LogComment.h"
#include "logTags.h"
#include "gadgets.h"
#include "globals.h"

int LogComment::TheEchoLevel = 0;
int LogComment::TheCurLevel = 0;
char LogComment::TheBuf[8*1024];

LogComment Comment; // note: assumes Comment is not used in static-ctors

LogComment::LogComment(): ostrstream(TheBuf, sizeof(TheBuf)) {
	configureStream(*this, 2);
}

ostream &endc(ostream &os) {
	os << ends;
	TheLog() << bege(lgComment) << Comment.str() << ende;
	if (Comment.TheCurLevel <= Comment.TheEchoLevel)
		cout << TheClock << "| " << Comment.str() << endl;
	Comment.reset();
	return os; 
}
