
/*
 * $Id: TmlModel.h,v 1.1.2.3 1999/02/22 02:51:06 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef TMP_LOCALITY_MODEL_H
#define TMP_LOCALITY_MODEL_H

#include "Future.h"

class RndDistr;

// temporal locality model
class TmlModel {
	public:
		TmlModel();

		void distDistr(RndDistr *aDistDistr) { theDistDistr = aDistDistr; }
		void searchDelta(int aDelta) { theSearchDelta = aDelta; }
		void planDepth(int maxDepth) { theFuture.capacity(maxDepth); }

		bool enabled() const { return theDistDistr; }

		int pickOid(bool cachable);
		bool addOid(int oid);
		void advance() { theFuture.shift(0); }

	protected:
		RndDistr *theDistDistr; // distances between requests
		int theSearchDelta;     // fuzzy selection: [best-d, best+d]

		Future<int> theFuture;
};

#endif
